/** Giddes
     - Graphical Interface for Designing Discrete Event Systems
  S.Laurie Ricker Ph.D
  
  Developed by I. Fraser & J. Taylor
  
  // reproduction without the express permission of Toba will
  // result in being taken outside and shot many times with a 
  // very tiny gun.
  
*/
/*
This is a wrapper class for a state pair, it was designed to be used with 
the table filling algorithm contained in class Fa.java
*/

package umdes;

public class StatePair
{
  public State first;
  public State second;
  private String name;
  
  public StatePair(State f, State s){
    first= new State(f);
    second= new State(s);
    setName();
  }
  
  public StatePair(StatePair s){
    first= new State(s.first);
    second= new State(s.second);
    setName();
  }
    
  public void flip(){
    State temp;
   
    temp=first;
    first=second;
    second=temp;
  }
  
  // null return if error!
  public State combineStates(){
    State result;
    
    // the State combineStates
    try{
      result=State.combineStates(first,second);
    }
    catch(Exception e){
      return null;
    }
     
    return(result);
  }
  
  
  public boolean equals(Object s){
    if(this==s)
    return(true);
    
    if(s==null)
    return(false);

    StatePair snew;
    try 
    {
      snew=(StatePair)s;
    }
    catch (ClassCastException cce)
    {
      return false;
    }
  
  
    if(!first.equals(snew.first))
    return(false);
  
    if(!second.equals(snew.second))
    return(false);
    
    return(true);
  }  

  
  public int hashCode(){
    int result=0;
    
    result=first.hashCode()%49;
    result=(int)StrictMath.sqrt(Integer.MAX_VALUE)*result+second.hashCode();
    
    return(result);
  } 
  
  /**
   * @return Returns the name.
   */
  
  public String getName() {
	return name;
  }
  /**
   * @param name The name to set.
   */
  public void setName() {
	name = "{"+first.getName()+","+second.getName()+"}";
  }
  public String toString(){
	  return "{" + first.name + ", " + second.name + "}";
  }
};
